<?php

if(!isSet($CCUHost)) $CCUHost = 'http://192.168.112.15:2001';
if(!isSet($CodeBase))$CodeBase= '';//'/user/HMTools/';
if(!isSet($PostUrl)) $PostUrl = '';
$SysMsg = '';	
$DeviceIdString='LEQ0500022:1';
error_reporting(0);
include_once('HMClass.php');
include_once('HMVariables.inc');

$VarBoolInputType='select';
$RenderFullPage=(isSet($_REQUEST['full']));
$VarShowMinMaxAsSuffix = true;
$VarShowDefaulAsSuffix = true;


// Prfen auf bergebene Werte
if(isSet($_REQUEST['device_id'])){
	$DeviceIdString=$_REQUEST['device_id'];
	$result=SaveEditContent($DeviceIdString);
	$SysMsg=$result['message'];
	echo CreateEditContent($DeviceIdString);
}else if(isSet($_REQUEST['id'])){
	$DeviceIdString=$_REQUEST['id'];
	echo CreateEditContent($DeviceIdString);
}
function _CreateContent($CCU=''){
global $CCUHost;
try{
	if(!$CCU)$CCU=$CCUHost;
	$api = new client_xmlrpc(array('url'=>$CCU));
	$devices=$api->listDevices();
	$varDefPro=[];
	foreach($devices as $nr=>$device){
//if($nr<99)continue;
	
		$DeviceIdString=$device['ADDRESS'];
		$ident=str_replace(':','_',$DeviceIdString);
		$vars=$api->getParamset($DeviceIdString,'MASTER');
		$vardefs=$api->getParamsetDescription($DeviceIdString,'MASTER');
		foreach($vars as $varName=>$varValue){
			$def=&$vardefs[$varName];
			$label='';
			if(!preg_match('/TEMPERATUR_(.*)_/',$varName,$m))
				preg_match('/TEMPERATURE_(.*)_/',$varName,$m);
			if(isSet($m[1])){
				switch($m[1]){
					case 'SUNDAY':$v='Sonntag';break;
					case 'MONDAY':$v='Montag';break;
					case 'THURSDAY':$v='Dienstag';break;
					case 'WEDNESDAY':$v='Mittwoch';break;
					case 'THURSDAY':$v='Donnerstag';break;
					case 'FRIDAY':$v='Freitag';break;
					case 'SATURDAY':$v='Samstag';break;
				}
				$label='Temperatur '.$v;
			}
			if(!$label){	
				preg_match('/TIMEOUT_(.*)_/',$varName,$m);
				if(isSet($m[1])){
					switch($m[1]){
						case 'SUNDAY':$v='Sonntag';break;
						case 'MONDAY':$v='Montag';break;
						case 'THURSDAY':$v='Dienstag';break;
						case 'WEDNESDAY':$v='Mittwoch';break;
						case 'THURSDAY':$v='Donnerstag';break;
						case 'FRIDAY':$v='Freitag';break;
						case 'SATURDAY':$v='Samstag';break;
					}
					$label='Zeitdauer '.$v;
				}
			}
			if(!$label){	
				preg_match('/ENDTIME_(.*)_/',$varName,$m);
				if(isSet($m[1])){
					switch($m[1]){
						case 'SUNDAY':$v='Sonntag';break;
						case 'MONDAY':$v='Montag';break;
						case 'THURSDAY':$v='Dienstag';break;
						case 'WEDNESDAY':$v='Mittwoch';break;
						case 'THURSDAY':$v='Donnerstag';break;
						case 'FRIDAY':$v='Freitag';break;
						case 'SATURDAY':$v='Samstag';break;
					}
					$label='Endzeit '.$v;
				}
			}
			if(!$label)$label=$varName;	

			if($def['TYPE']=='ENUM'){
					
				
				$ta=[];
				foreach($def['VALUE_LIST'] as $id=>$value){
					$ta[]="'$value'=>'$value'";
				}
				$cont[$varName]="\$VarNameDef['$varName']=Array('$label',".implode(',',$ta).");";
			}else 
				$cont[$varName]="\$VarNameDef['$varName']='$label';";
		}
		$heigths[$ident]="\$FrameHeigth['$ident']=".count($vars).";";
		
//		if($nr>199)break;
	}
	foreach($cont as $n=>$v){
		echo "$v<br>";
	}	
	foreach($heigths as $n=>$v){
		echo "$v<br>";
	}	
	
}catch (Exception $e){
	print_r($e->getMessage());
}
}	
	
function __CreateEditFieldFromDef($varName, $varValue, $def=null){
global $VarNameDef,$VarBoolInputType,$VarBoolDef,$VarShowMinMaxAsSuffix,$VarShowDefaulAsSuffix;
	$list=$min=$max=$t=null;
	if($tmp=@$VarNameDef[$varName]){
		if(is_array($tmp)){
			$varLabel=array_shift($tmp);
			$list=$tmp;
		}else $varLabel=$tmp;	
	}else $varLabel=$varName;
	$tmp=explode('|',$varLabel);
	$varLabel=$tmp[0]; $suffix=(isSet($tmp[1]))?'&nbsp;'.$tmp[1]:'';
	if(!$def||!isSet($def['TYPE'])){
		if($list){
			$def['TYPE']='ENUM';
			$def['VALUE_LIST']=array_keys($list);
		}else $def['TYPE']=strtoupper(gettype($varValue));
	}
	switch($def['TYPE']){
		case 'BOOLEAN' :
		case 'BOOL' :
			switch ($VarBoolInputType) {
				case 'select' : 
					$t="<select name=\"$varName\" id=\"$varName\">";
					$t.="<option value=\"0\"".(!$varValue?' selected=""':'').">{$VarBoolDef[false]}</option>";
					$t.="<option value=\"1\"".($varValue?' selected=""':'').">{$VarBoolDef[true]}</option>";
					$t.="</select>";	
					break;
				case 'radio':
					$t="{$VarBoolDef[false]} <input type=\"radio\" name=\"$varName\"  id=\"$varName\" value=\"0\"".(!$varValue?' checked="true"':'').">";
					$t.="{$VarBoolDef[true]} <input type=\"radio\" name=\"$varName\"  value=\"1\"".($varValue?' checked="true"':'').">";
					break;
			}
			if($VarShowDefaulAsSuffix===true&&isSet($def['DEFAULT'])){		
				$tn=$VarBoolDef[(bool)$def['DEFAULT']];
				$suffix.=($suffix)?' (Vorgabe '.$tn.')':'&nbsp;&nbsp;Vorgabe '.$tn;
			}
			break;
		case 'FLOAT':
		case 'DOUBLE':
			$float=' float="1"';
		case 'INTEGER':
			if(!isSet($float))$float='';
			$min=$def['MIN'];$max=$def['MAX'];
			if($VarShowMinMaxAsSuffix===true){
				if($min||$max){
					$suffix="&nbsp; $min bis $max".$suffix;
					if($VarShowDefaulAsSuffix&&isSet($def['DEFAULT']))$suffix.=($suffix)?' (Vorgabe '.$def['DEFAULT'].')':'&nbsp;&nbsp;Vorgabe '.$def['DEFAULT'];
					$title='';
				}else $title="title=\"Der Wert fr $varLabel muss zwischen $min und $max liegen\""; 
			}
			if($min||$max){
				$t="<input type=\"text\"$float min=\"$min\" max=\"$max\" name=\"$varName\" info=\"$varLabel\"$title value=\"$varValue\" size=\"8\" id=\"$varName\" onkeypress=\"return CheckKeyPress(event,this);\" onblur=\"CheckValueData(this)\" >";
			}else
				$t="<input type=\"text\"$float name=\"$varName\" info=\"$varLabel\" title=\"$varTip\" value=\"$varValue\" size=\"8\" id=\"$varName\" onkeypress=\"return CheckKeyPress(event,this);\">";
			break;
		case 'STRING':
			$t="<input type=\"text\" name=\"$varName\" value=\"$varValue\" id=\"$varName\">";
			break;
		case 'ENUM':
			foreach($def['VALUE_LIST'] as $id=>$value){
				$tn=@$list[$value];	if(!$tn)$tn=$value;
				$ta[]="<option value=\"$id\"".(($id==$varValue)?' selected=""':'').">$tn</option>";
			}
			$t="<select name=\"$varName\" id=\"$varName\">".implode($ta)."</select>";
			if($VarShowDefaulAsSuffix===true&&isSet($def['DEFAULT'])){		
				$tn=@$def['VALUE_LIST'][$def['DEFAULT']];
				if($tn && isSet($list[$tn]))$tn=$list[$tn];
				$suffix.=($suffix)?' (Vorgabe '.$tn.')':'&nbsp;&nbsp;Vorgabe '.$tn;
			}
			break;
		default: 
			return null;
			echo "TYPE: {$def['TYPE']} = $varName = $varValue<br>";
			dumpvar($vardefs);
			exit;
	}
	return array('label'=>$varLabel,''=>$min,'max'=>$max,'content'=>$t,'suffix'=>$suffix);
}	

	
function CreateEditorContent($DeviceIdString, $CCU=''){
global 	$CCUHost, $PostUrl,$SysMsg, $RenderFullPage,
		$VarShowMinMaxAsSuffix,$VarShowDefaulAsSuffix;
try{
	if(!$CCU)$CCU=$CCUHost;
	$api = new client_xmlrpc(array('url'=>$CCU));
	$device=$api->getDeviceDescription($DeviceIdString);
	$vars=$api->getParamset($DeviceIdString,'MASTER');
	$vardefs=$api->getParamsetDescription($DeviceIdString,'MASTER');
	$isSubDevice=(strpos($DeviceIdString,':')!==false);
	$deviceName=($isSubDevice)?"{$device['PARENT_TYPE']} => {$device['TYPE']}":$device['TYPE'];
	$ident=str_replace(':','_',$DeviceIdString);
	$js=$ta=$fields=[]; 

	foreach($vars as $varName=>$varValue){
		$def=&$vardefs[$varName];
		if($r=__CreateEditFieldFromDef($varName,$varValue,$def)){
			if($r['min']||$r['max'])$js[]="		if(!CheckValueData(f['$varName']))ok=false;";
			if($VarShowDefaulAsSuffix||$VarShowMinMaxAsSuffix){
				$fields[]="<tr><td style=\"white-space: nowrap;\"><label for=\"$varName\">{$r['label']}:</label></td><td>{$r['content']}</td><td>{$r['suffix']}</td></tr>";
			}else {
				$fields[]="<tr><td style=\"white-space: nowrap;\"><label for=\"$varName\">{$r['label']}:</label></td><td>{$r['content']}{$r['suffix']}</td></tr>";
			}
		}
		$ta[]="$varName:'".((isSet($def['DEFAULT']))?"{$def['DEFAULT']}'":"0'");
	}
	$checkScript="function check_$ident(){
		var f=document.getElementById('form_$ident');
		var ok=true;\n".implode("\n",$js)."\nreturn ok;};";
	$defaultScript="function setDefaults_$ident(){
		var d={".implode(',',$ta)."};
		var f=document.getElementById('form_$ident');
		for(var name in d){
			UnCheckValueData(name);
			f[name].value=d[name];
		}
	}";	
	$script="<SCRIPT>\n$checkScript\n$defaultScript\n</SCRIPT>\n";
	$content="<form id=\"form_$ident\" method=\"get\" action=\"$PostUrl\" onsubmit=\"return check_$ident();\">";
	$content.="<fieldset><legend>$deviceName</legend>";
	$content.="<table cellpadding=\"1\" cellspacing=\"0\">".implode("\n",$fields)."</table>";
	$content.="<input type=\"hidden\" name=\"device_id\" value=\"$DeviceIdString\">";
	if($RenderFullPage)$content.="<input type=\"hidden\" name=\"full\" value=\"1\">";
	if($SysMsg)$content.="<fieldset><legend>Nachricht:</legend>$SysMsg</fieldset>";
	$content.="<hr  style=\"height: 1px\"><input type=\"submit\" name=\"SAVE\" value=\"Speichern\">";
	$content.="&nbsp;<input type=\"reset\" name=\"_RESET_\" value=\"Zurcksetzen\">";
	$content.="&nbsp;<input type=\"button\" name=\"_DEFAULTS_\" value=\"Standard Werte laden\" onclick=\"setDefaults_$ident()\">";
	$content.="</fieldset></form>";
	return $script.$content;
} catch (Exception $e){
	print_r($e->getMessage());
	return null;
}
	
}		

function CreateEditContent($DeviceIdString, $CCU=''){
global $CCUHost,$CodeBase,$RenderFullPage;	
	$content='';
	if($RenderFullPage){
		$content.=<<<DATA
<!DOCTYPE HTML>
<HTML>
<HEAD>
	<META content="text/html; charset=utf-8" http-equiv="Content-Type" />
	<META NAME="Author" CONTENT="Xaver Bauer">
	<META name="date" content="24.01.2015" />
	<META name="created" content="24.01.2015" />
	<META name="Keywords" content="">
	<META name="Description" content="">
	<META name="Robots" content="index, follow">
	<META name="verify-v1" content="" />
	<TITLE>HomeMatic Property Editor</TITLE>
</HEAD>\n<BODY>\n
DATA;
	}
	$content.="<LINK href=\"{$CodeBase}HMTools.css\" type=\"text/css\" rel=\"stylesheet\"/>
<SCRIPT src=\"{$CodeBase}HMTools.js\" type=\"text/javascript\" charset=\"utf-8\"></SCRIPT>\n";

	$content.=CreateEditorContent($DeviceIdString);
	$content.='<style> 
	body,html {
		font-family: arial,sans-serif;
		font-size: 17px;
		color:silver;
		}
	legend {
		font-family: "Arial Narrow",arial,sans-serif;
		font-size: 19px;
	}
	</style>';
	if($RenderFullPage)$content.='</BODY></HTML>';
	return $content;
}

function SaveEditContent($DeviceIdString, $CCU=''){
global $CCUHost;
	if(!$CCU)$CCU=$CCUHost;
	try{
		$api = new client_xmlrpc(array('url'=>$CCU));
		$vars=$api->getParamset($DeviceIdString,'MASTER');
		$vardefs=$api->getParamsetDescription($DeviceIdString,'MASTER');
		$error=$modified=null;
		foreach($vars as $varName=>$varValue){
			$def=&$vardefs[$varName];
			if(!isset($_REQUEST[$varName]))continue;
			$value=trim($_REQUEST[$varName]);
			switch($def['TYPE']){
				case 'BOOL' :
					$value=(bool)$value;
					$min=$max=null;
					break;
				case 'FLOAT':
					$value=(float)$value;
					$min=$def['MIN'];$max=$def['MAX'];
					break;
				case 'INTEGER':
					$value=(integer)$value;
					$min=$def['MIN'];$max=$def['MAX'];
					break;
				case 'STRING':
					$value=(string)$value;
					break;
				case 'ENUM':
					$value=(integer)$value;
					$min=$def['MIN'];$max=$def['MAX'];
					break;
			}
			if($min||$max){
				if($value<$min||$value>$max){
					$error='Min Max Error';
					break;
				}
			}
			if($vars[$varName]!=$value)$modified=true;
			$vars[$varName]=$value;
		}
		if($error){
			$r=array('state'=>'ERROR','message'=>$error);
		}elseif($modified){	
			$ok=$api->putParamset($DeviceIdString,'MASTER',$vars);
			$r=array('state'=>'OK','message'=>'gespeichert');
		}else $r=array('state'=>'OK','message'=>'keine nderung');
		return $r;
	} catch (Exception $e){
		return array('state'=>'ERROR','message'=>$e->getMessage());
	}	
}

?>