if(typeof CheckValueData == 'undefined') {
	var CONFIG={
		inputErrorColor:['#FFFF00','#800000'],
		inputColor:['#000000','#FFFFFF']
	};	
	
	function CheckValueData(field, showAlert){
		var min=(typeof field.min != 'undefined')?field.min:0;
		var max=(typeof field.max != 'undefined')?field.max:0;
		var nam=(typeof field.info!= 'undefined')?field.info:field.name;
		if(min==max)return true;
		var v=parseFloat(field.value);
		if(v<min){
			var m='Eingegeber Wert '+v+' liegt unter dem zulssigen Wert von '+min;
		}else if(v>max){
			var m='Eingegeber Wert '+v+' liegt ber dem zulssigen Wert von '+max;
		}else {
			SetFieldColors(field,CONFIG.inputColor);
			return true;
		}
		SetFieldColors(field,CONFIG.inputErrorColor);
		if(typeof showAlert == 'undefined')showAlert=true;
		if(showAlert)alert(nam+" - FEHLER!!\n"+m+"\n\nDer Wert fr "+nam+" muss zwischen "+min+" und "+max+" liegen!");
		return false;
	}
	function UnCheckValueData(field){
		SetFieldColors(field,CONFIG.inputColor);
	}
	function SetFieldColors(field,colors){
		if(typeof field.style=='undefined'){
			field.style='background-color="'+colors[1]+'";color="'+colors[0]+'"'; 
		}else{
			field.style.color=colors[0];
			field.style.backgroundColor=colors[1];
		}
	}
	function CheckKeyPress(event,field) {
		if(!event)event=window.event;
		if (event.which){keycode=event.which;}else if(event.keyCode){keycode=event.keyCode;}
		if(typeof field.min != 'undefined')CheckValueData(field,false);
		if(keycode<32||keycode>57){
			if(keycode==190&& (typeof field.isfloat!='undefined'))return true;
			if(keycode==8||keycode==13||keycode==27)return true;
			return false;
		}
		return true;
	}	
 	
	
}